﻿using Syncfusion.UI.Xaml.Charts;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace ScrollingDemo
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        double actualMaximum;
        private SfChart chart;
        DispatcherTimer timer = new DispatcherTimer();
        DateTime date;
        public MainPage()
        {
            this.InitializeComponent();
            date = new DateTime();
            chart = Chart1;
        }

        private void XAxis_ActualRangeChanged(object sender, ActualRangeChangedEventArgs e)
        {
            actualMaximum = (double)e.ActualMaximum;
            if (!(sender as ChartAxis).VisibleRange.IsEmpty)
            {
                var visibleMaximum = (sender as ChartAxis).VisibleRange.End;
                var index = (this.chart.Series[0].ItemsSource as ProductDetails).Count - 1;
                for (; (actualMaximum == visibleMaximum); index++)
                {
                    date = (this.chart.Series[0].ItemsSource as ProductDetails)[index].Speed.AddMinutes(1);
                    Random rand = new Random();
                    (this.chart.Series[0].ItemsSource as ProductDetails).Add(new Product() { Speed = date, Rate = rand.Next(110, 240) });
                    actualMaximum = (this.chart.Series[0].ItemsSource as ProductDetails).Count - 1;
                }
            }
        }


        private void timer_Tick(object sender, object e)
        {
            date = (this.chart.Series[0].ItemsSource as ProductDetails)
                [(this.chart.Series[0].ItemsSource as ProductDetails).Count - 1].Speed.AddMinutes(1);
            Random rand = new Random();
            (this.chart.Series[0].ItemsSource as ProductDetails).Add(new Product() { Speed = date, Rate = rand.Next(100, 250) });
        }

    }

    public class Product
    {
        public DateTime Speed
        {
            get;
            set;
        }

        public DateTime Date
        {
            get;
            set;
        }

        public double Rate
        {
            get;
            set;
        }
    }

    public class ProductDetails : ObservableCollection<Product>
    {
        public ProductDetails()
        {
            Random rand = new Random();
            DateTime dt = DateTime.Now;

            for (int i = 11; i < 140; i++)
            {
                this.Add(new Product { Rate = rand.Next(110, 240), Speed = dt });
                dt = dt.AddMinutes(i);
            }

        }
    }
}
